#!/usr/bin/php
<?php
if(php_sapi_name() != 'cli') die('Det hr tycker jag inte om...');

define('ELECTION_NBR',12);
define('ANTAL_MANDAT',27);

$candidates = $voters = $votes = array();

/************************************************************
	Candidates
*************************************************************/
$input = file_get_contents('candidates');

preg_match_all('%^"(?<nbr>\d+)";"(?<electionNbr>\d+)";"(?<name>.+?)";"(?<district>.*?)";"(?<year>\d+)";(?:"(?<text>.*?)")?$%sm', $input, $matches, PREG_SET_ORDER);

foreach($matches as $match){
	$candidates[$match['nbr']] = array();

	foreach($match as $field_name=>$field_val){
		if(is_numeric($field_name)) continue;
		$candidates[$match['nbr']][$field_name] = $field_val;
	}
}

/************************************************************
	Voters
*************************************************************/
$input = file_get_contents('voters');

preg_match_all('%^"(?<nbr>\d+)";"(?<electionNbr>\d+)";"(?<name>.+?)";"(?<password>.*?)";(?:"(?<voted>.+?)")?$%m', $input, $matches, PREG_SET_ORDER);

foreach($matches as $match){
	$voters[$match['nbr']] = array();

	foreach($match as $field_name=>$field_val){
		if(is_numeric($field_name)) continue;
		$voters[$match['nbr']][$field_name] = $field_val;
	}
}

/************************************************************
	Votes
*************************************************************/
$input = file_get_contents('votes');

preg_match_all('%^"(?<nbr>\d+)";"(?<electionNbr>\d+)";"(?<voteNbr>.+?)";"(?<vote>.*?)"$%m', $input, $matches, PREG_SET_ORDER);

foreach($matches as $match){
	$votes[$match['nbr']] = array();

	foreach($match as $field_name=>$field_val){
		if(is_numeric($field_name)) continue;
		$votes[$match['nbr']][$field_name] = $field_val;
	}
}



/************************************************************
	Mappa personnummer => md5
*************************************************************/
$md5_map = array();
foreach($voters as $user){
	$md5_map[md5($user['name'])] = $user['name'];
}

/************************************************************
	Mappa personnummer => namn
*************************************************************/
$civic_reg_map = array();

$input = file('members');

foreach($input as $row){

	preg_match('%^"(?<id>\d+)";"(?<civic_reg_number>.+?)";"(?<firstname>.+?)";("(?<nickname>.+?)")?;"(?<lastname>.*?)"%m', $row, $matches);
        $civic_reg_map[$matches['civic_reg_number']] = "{$matches['firstname']} {$matches['lastname']}";
}

/************************************************************
	Rkna ut resultatet
*************************************************************/
$results = array();

foreach($votes as $row){
	$person_votes = explode('::',$row['vote']);
	$position = 0;
	foreach($person_votes as $single_vote){
		if(!$single_vote) continue; //Bort med sista elementet d det r tomt
		
		$position++;
		
		if(!$results[$single_vote]) $results[$single_vote] = array();

		$results[$single_vote][$row['voteNbr']] = $position;
	}
}

foreach($results as $person=>$given_votes)
	if($candidates[$person]['electionNbr'] != ELECTION_NBR) unset($results[$person]);

uasort($results, create_function('$a, $b',' return count($b)-count($a);'));

$i = 1;
foreach($results as $person=>$given_votes){
	echo "$i. $person | {$candidates[$person]['name']} | {$candidates[$person]['district']}{$candidates[$person]['year']} | ".count($given_votes);
	echo "\n";

	foreach($given_votes as $hash=>$pos){
		$civic_reg_number = $md5_map[$hash];
		$name = $civic_reg_map[$civic_reg_number] ? $civic_reg_map[$civic_reg_number] : $civic_reg_number;
		echo "$name:$pos";
		echo ', ';
	}

	echo "\n\n--------------------------------------------------------------------\n";
	
	$i++;
}

	
$total_nbr_votes = count($votes);
$choosen = array();
$rejected = array();
$first_hand_votes = array();

$candidates_votes = array();
foreach($votes as $row){
	if($row['electionNbr'] != ELECTION_NBR) continue;
	$person_votes = explode('::',$row['vote']);
	$position = 0;
	foreach($person_votes as $single_vote){
		if(!$single_vote) continue; //Bort med sista elementet d det r tomt

		$candidates_votes[$row['voteNbr']][] = $single_vote;
	}

}


foreach($candidates_votes as $person=>$given_votes){
	$first_hand_votes[array_shift($given_votes)][] = $person;
}

while(count($choosen) < 27){
	//Kolla ifall ngon har ftt tillrckligt med rster
	foreach($first_hand_votes as $candidate=>$given_votes){
		if(count($given_votes) > ($total_nbr_votes/(ANTAL_MANDAT+1))+1){
			$choosen[$candidate] = true;
			unset($first_hand_votes[$candidate]);
		}
	}

	uasort($first_hand_votes, create_function('$a, $b',' return count($b)-count($a);'));

	//Ta hand om de som har frstahandsrstat p den sista person
	$keys = array_keys($first_hand_votes);
	$rejected_person = $keys[count($keys)-1];
	$rejected[$rejected_person] = true;

	if(!$rejected_person) break;  //TODO: ta bort mig

	$rejected[$rejected_person] = true;
	
	//Flytta ver s att vi rknar andravalsrsterna istllet
	foreach($first_hand_votes[$rejected_person] as $voter){
		foreach($candidates_votes[$voter] as $votes){
			if(!$choosen[$votes] && !$rejected[$votes]){
				$first_hand_votes[$votes][] = $voter;
				break;
			}
		}
	}

	unset($first_hand_votes[$rejected_person]);
	
	foreach($first_hand_votes as $key=>$val)
		echo $key . '|' . count($val) . "\n";

	echo "--------\n";

}
$i = 1;
foreach($choosen as $person=>$null){
	echo "$i. $person | {$candidates[$person]['name']} | {$candidates[$person]['district']}{$candidates[$person]['year']}";
        echo "\n";
	$i++;
}

#print_r($candidates);
#print_r($voters);
#print_r($votes);
?>

