<?php
class Ballot {
	private $exhausted = false;
	
	private $preferences = array();
	private $vote_value = 0;

	public function __construct($incoming) {
		foreach($incoming as $intention) {
			$this->preferences[$intention] = 0;
		}
	}

	/*
		Returns true if exhausted, else false.
	*/
	public function nextIteration() {
		$this->checkForExhaust();
		
		if($this->isExhausted()){
			return true;
		}

		$this->vote_value = 1;
		foreach($this->preferences as $candidate_id=>&$value){
			$value = 0;
		}
		//$preference_ids = array_keys($this->preferences);
		//$first_candidate = array_shift($preference_ids);
		//$this->preferences[$first_candidate] = 1;

		return false;
	}

	public function isExhausted() {
		return $this->exhausted;
	}

	public function checkForExhaust() {
		global $continuing_candidates;
		foreach($this->preferences as $candidate_id => $vote_value){
			if(!isset($continuing_candidates[$candidate_id]))
				unset($this->preferences[$candidate_id]);
		}

		if(count($this->preferences)==0){
			$this->exhausted = true;
			$this->vote_value = 0;
		}

	}

	public function getPreferences() {
		return $this->preferences;
	}

	public function getValue() {
		return $this->vote_value;
	}

	public function getCandidateValue($candidate_id) {
		return $this->preferences[$candidate_id];
	}

	public function addVote($candidate_id) {
		$this->preferences[$candidate_id] += $this->vote_value;
		//echo "Röstar på $candidate_id med {$this->vote_value}\n";
		$this->vote_value=0;
	}

	public function subtractBeforeSurplusTransferValue($candidate_id, $amount) {
		$this->vote_value = $amount;
		$this->preferences[$candidate_id] -= $amount;

		if($this->preferences[$candidate_id] < 0){
			throw new Exception("$candidate_id har fått en negativ röst");
		}
	}

	/*
	Returns true if exhausted.
	*/
	public function doSurplusValueTransfer($provisional_candidates, $provisional_elected_candidate_id) {
		global $continuing_candidates;

		$transfered = false;

		foreach($this->preferences as $candidate_id=>&$amount){
			if($candidate_id != $provisional_elected_candidate_id && !isset($provisional_candidates[$candidate_id])){
				$continuing_candidates[$candidate_id]->addVote($this, $candidate_id);
				$transfered = true;
				break;
			}
		}

		if(!$transfered) {
			$this->exhausted = false;
			return true; 
		}

		return false;
	}

}


?>
